Ruby master - Misc #12283

Obsolete ChangeLog and commit message in Git-style
04/14/2016 06:57 PM - naruse (Yui NARUSE)

Status: Closed

Priority: Normal

Assignee: naruse (Yui NARUSE)
Description

How about Git-style commit message instead of ChangelLog?

Proposal

After we reach the consensus
1. Write a commit message in Git-style.
e Line 1: summary of commit (around 80 characters or less, <50 is better)
e Line 2: empty line

e Line 3-: More detailed explanation of commit

See also: https://git-scm.com/book/ch5-2.htmI#Commit-Guidelines

1. Stop manually edit ChangelLog and auto-generate on make dist.

Rationale

A good commit message should include the objective of the commit.

Committers should write "what purpose the change is for".

In this sense, Changelog is not a good format. It lists per-file changes, so committers tend to write just "how the files were
changed".

Also, Changelog causes commit conflicts frequently.

Though it is not related with the actual commit.
People who uses svn/git should see the log with it; Changelog is only for tarball users.

Status

mame made this proposal at the developers' meeting (13 Apr.), and there was no objection.

Matz agreed with this proposal, provided that a ChangelLog-like plain-text file is generated from the commit log.
The release manager will create the file when Ruby is released.

Note

This ticket does NOT propose a migration from SVN to Git. Never discuss that in this ticket.

Related issues:
Related to Ruby master - Bug #12908: make-snapshot is broken Closed

Associated revisions

Revision 8c5ae893 - 11/05/2016 06:09 PM - naruse (Yui NARUSE)
Add Changelog-2015 as an anchor of new ChangelLog see #12283

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56612 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 56612 - 11/05/2016 06:09 PM - naruse (Yui NARUSE)
Add Changelog-2015 as an anchor of new ChangelLog see #12283

Revision 56612 - 11/05/2016 06:09 PM - naruse (Yui NARUSE)
Add Changelog-2015 as an anchor of new ChangelLog see #12283
Revision 56612 - 11/05/2016 06:09 PM - naruse (Yui NARUSE)
Add ChangelLog-2015 as an anchor of new Changelog see #12283

Revision 56612 - 11/05/2016 06:09 PM - naruse (Yui NARUSE)
Add ChangelLog-2015 as an anchor of new Changelog see #12283

Revision f7f00b89 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

e tool/ves.rb (export_changelog): generate Changelog file from
ves's log. [Feature #12283]

¢ tool/make-snapshot (package): overwrite Changelog by generated
Changelog.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56638 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 56638 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

e tool/ves.rb (export_changelog): generate Changelog file from
vcs's log. [Feature #12283]

¢ tool/make-snapshot (package): overwrite ChangelLog by generated
Changelog.

Revision 56638 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

e tool/ves.rb (export_changelog): generate Changelog file from
vcs's log. [Feature #12283]

¢ tool/make-snapshot (package): overwrite ChangelLog by generated
Changelog.

Revision 56638 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

e tool/ves.rb (export_changelog): generate Changelog file from
vcs's log. [Feature #12283]

¢ tool/make-snapshot (package): overwrite Changelog by generated
Changelog.

Revision 56638 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

e tool/ves.rb (export_changelog): generate Changelog file from
vcs's log. [Feature #12283]

e tool/make-snapshot (package): overwrite Changelog by generated
Changelog.

Revision 4e9a5a3e - 11/06/2016 03:56 PM - naruse (Yui NARUSE)
Obsolete Changelog [Feature #12283]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56645 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 56645 - 11/06/2016 03:56 PM - naruse (Yui NARUSE)
Obsolete Changelog [Feature #12283]

Revision 56645 - 11/06/2016 03:56 PM - naruse (Yui NARUSE)
Obsolete Changelog [Feature #12283]

Revision 56645 - 11/06/2016 03:56 PM - naruse (Yui NARUSE)
Obsolete Changelog [Feature #12283]

Revision 56645 - 11/06/2016 03:56 PM - naruse (Yui NARUSE)
Obsolete Changelog [Feature #12283]

History

#1 - 04/14/2016 06:58 PM - naruse (Yui NARUSE)

- Tracker changed from Bug to Misc

#2 - 04/14/2016 09:51 PM - normalperson (Eric Wong)
naruse@airemix.jp wrote:

How about Git-style commit message instead of ChangelLog?

Yes please :)

The current changelog format is a very annoying barrier to
making commits; especially for applying patches from others.

Matz agreed with this proposal, provided that a ChangelLog-like plain-text file is generated from the commit log.

| don't even think that's necessary; NEWS file with pointers to
SVN/git history is enough.

#3 - 04/18/2016 09:00 AM - duerst (Martin Diirst)

| welcome this proposal. It makes committing easier. Can you please tell us when this proposal will actually start? | see people still committing
Changelog changes.

#4 - 04/19/2016 04:33 AM - sonots (Naotoshi Seo)

| am positive this proposal, too. ChangelLog often conflicts and | encountered with conflicts today, too.
#5 - 04/20/2016 01:39 AM - shyouhei (Shyouhei Urabe)
Seems no one is against abandoning Changelog.
What about "a Changelog-like plain-text file" part?
#6 - 04/24/2016 03:47 PM - naruse (Yui NARUSE)
Shyouhei Urabe wrote:
Seems no one is against abandoning Changelog.
What about "a Changelog-like plain-text file" part?
One idea is just svn log -rHEAD:53286, and we can customize the format further.
(I use git show git merge-base trunk origin/ruby_2_3 to show the commit)
TODO:

® How to get the beginning revision of the branch with subversion.
¢ What format the new ChangLog should be.
#7 - 04/24/2016 06:41 PM - normalperson (Eric Wong)
naruse@airemix.jp wrote:

Shyouhei Urabe wrote:
Seems no one is against abandoning Changelog.

What about "a Changelog-like plain-text file" part?

| don't think it's useful given how prevalent git and SVN are
among developers. NEWS is much more useful to end users.

One idea is just svn log -rHEAD:53286, and we can customize the format further.

(I use git show git merge-base trunk origin/ruby_2_3 to show the commit)
TODO:

® How to get the beginning revision of the branch with subversion.

We can document that in NEWS.

#8 - 04/26/2016 07:51 PM - normalperson (Eric Wong)
naruse@airemix.jp wrote:

1. Write a commit message in Git-style.

Line 1: summary of commit (around 80 characters or less, <50 is better)
Line 2: empty line
Line 3-: More detailed explanation of commit

Fwiw, | already do that in my commits. | would also like

stable branch maintainers to maintain the summary when merging,
and refer to trunk commit in message body.

(Use "-x" in "git cherry-pick -x")

For example, oneline view of ten v2_3.0..v2_3_1 changes in Ruby
is not very informative by itself:

$ git log --abbrev-commit --pretty=oneline -10 v2_3_0..v2_3 1
5827d8e add tag v2_3_1

394fa89 version.h: bump up teeny. 2.3.0 -> 2.3.1.

52¢883b merge revision(s) 53320,54756: [Backport #12246]
2d360c5 merge revision(s) 54755: [Backport #12313]
7f36210 merge revision(s) 54758:

6ccec9e9 merge revision(s) 54716,54719,54750: [Backport #12314]
7b70f0e merge revision(s) 54720: [Backport #12184]

ab3376b merge revision(s) 54681: [Backport #12302]

b8aa410 merge revision(s) 54141,54542 54548: [Backport #12082]
9224427 merge revision(s) 54423,54489: [Backport #12201] [Backport #12202]

Compare the above output with Linux v4.5.1..v4.5.2:

$ git log --abbrev-commit --pretty=oneline -10 v4.5.1..v4.5.2

92b8a3b Linux 4.5.2

9378a3b staging: android: ion: Set the length of the DMA sg entries in buffer
383b59f HID: usbhid: fix inconsistent reset/resume/reset-resume behavior

2fa2fc1 HID: wacom: fix Bamboo ONE oops

9bfe5a5 ALSA: usb-audio: Skip volume controls triggers hangup on Dell USB Dock
1b040b3 ALSA: usb-audio: Add a quirk for Plantronics BT300

4e088a6 ALSA: usb-audio: Add a sample rate quirk for Phoenix Audio TMX320
0e3d5c4 ALSA: hda/realtek - Enable the ALC292 dock fixup on the Thinkpad T460s
285947f ALSA: hda - Fix regression of monitor_present flag in eld proc file

9e91bf3 mmc: sdhci-pci: Add support and PCI IDs for more Broxton host controllers

Note: | suggest cloning linux.git with bundle for resumability and
to reduce server load:

https://www.kernel.org/cloning-linux-from-a-bundle.html

11/16/2019

4/5


mailto:naruse@airemix.jp
mailto:naruse@airemix.jp
https://redmine.ruby-lang.org/issues/12246
https://redmine.ruby-lang.org/issues/12313
https://redmine.ruby-lang.org/issues/12314
https://redmine.ruby-lang.org/issues/12184
https://redmine.ruby-lang.org/issues/12302
https://redmine.ruby-lang.org/issues/12082
https://redmine.ruby-lang.org/issues/12201
https://redmine.ruby-lang.org/issues/12202
https://www.kernel.org/cloning-linux-from-a-bundle.html

(Git hackers thinking of ways to make cloning large repos more
efficient and resumable :)

#9 - 05/10/2016 07:44 AM - shevegen (Robert A. Heiler)
| personally have no preference either way.
| should however had also note that I like the current changelog format:

https://github.com/ruby/ruby/blob/trunk/Changelog

It sort of is easy for me to read what is new, what is changed, what
is being worked on etc...

For me who is more or less a casual ruby user, writing mostly just ruby
code, it allows me to keep track of that in a very easy manner.

Matz agreed with this proposal, provided that a ChangelLog-like plain-text file is generated from the commit log.

| don't even think that's necessary; NEWS file with pointers to
SVN/git history is enough.

| like the changelogs more than the NEWS file - | don't even look
at the news file much at all, easier to keep track of current
changes as they happen. :-)

#10 - 05/18/2016 12:14 AM - shyouhei (Shyouhei Urabe)
| asked matz why he need a Changelog yesterday. He answered that the problem is svn log. It requires network connection, and is painfully slow.

At least until we give up subversion, there should be a file-based ChangelLog-ish mechanism. Matz said it's OK for him to auto-generate such thing
from commit comments.

Once we equipped a subversion hook script to auto-generate a Changelog, we can start migrate this way.

#11 - 06/13/2016 06:14 AM - shyouhei (Shyouhei Urabe)
- Assignee set to naruse (Yui NARUSE)

- Status changed from Open to Assigned

#12 - 11/06/2016 12:57 PM - naruse (Yui NARUSE)

- Status changed from Assigned to Closed

Applied in changeset r56638.

e tool/vcs.rb (export_changelog): generate Changelog file from
ves's log. [Feature #12283]

¢ tool/make-snapshot (package): overwrite ChangelLog by generated
Changelog.

#13 - 11/07/2016 12:13 AM - shyouhei (Shyouhei Urabe)
m

So is it now open? Can we commit without Changelog entry?

#14 - 11/07/2016 09:35 AM - vo.x (Vit Ondruch)
- Related to Bug #12908: make-snapshot is broken added
